<?php

/*****************************************************************************

    Mysta - Tiny web framework.

    Copyright (C) 2012  Fabien LOISON

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

*****************************************************************************/


/**
 * @file
 *
 * This file contains functions related to the http codes
 */


/**
 * Redirect to the given url.
 *
 * @param $url
 *   The url where the client will be redirected.
 */
function redirect($url)
{
	header('Location: ' . $url);
	die();
}


/**
 * Abort the page generation with a custom http code.
 *
 * @param $code
 *   The http code:
 *     - 403 Forbidden
 *     - 404 Not Found
 *     - 418 I’m a teapot
 *     - 500 Internal Server Error
 */
function abort($code)
{
	$error = '500 Internal Server Error';
	switch ($code)
	{
		case 403:
			$error = '403 Forbidden';
			break;
		case 404:
			$error = '404 Not Found';
			break;
		case 418:
			$error = '418 I\'m a teapot';
			break;
	}

	header('HTTP/1.0 ' . $error);
	echo '<html><head><title>' . $error . '</title></head><body><h1>' . $error . '</h1></body></html>';
	die();
}
