<?php

/*****************************************************************************

    Mysta - Tiny web framework.

    Copyright (C) 2012  Fabien LOISON

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
	along with this program.  If not, see <http://www.gnu.org/licenses/>.

*****************************************************************************/


/**
 * @file
 *
 * This file contains functions related to the templating with Twig.
 */


require_once './lib/Twig/Autoloader.php';


/**
 * Render a template.
 *
 * @param $template
 *   The template name
 *
 * @param $param
 *   An associative array with all the needed parameters of the template.
 *
 * @return
 *   The generated html page.
 */
function render_template($template, $param=array())
{
	global $twig;
	return $twig->render($template, $param);
}


Twig_Autoloader::register();
$twig = new Twig_Environment(new Twig_Loader_Filesystem('./templates'));

//Extends Twig...
$twig->addFunction('url_for', new Twig_Function_Function('url_for'));
$twig->addFunction('render_form', new Twig_Function_Function('render_form'));
